﻿#pragma strict

//Moving
static var moving : boolean = false;
private var movingLeft : boolean = false;
private var movingRight : boolean = false;
private var movingDown : boolean = false;
private var movingUp : boolean = false;

//Player Position
static var xPlayer : float;
static var zPlayer : float;

//Movement
private var speed : float = 4;
private var distance : float = 1;

//Target Position
private var xTarget : int;
private var zTarget : int;

function Update()
{
	xPlayer = gameObject.transform.position.x;
	zPlayer = gameObject.transform.position.z;
	
	
	if (!movingLeft && !movingRight && !movingDown && !movingUp )
		moving = false;
	else
		moving = true;
	
	
	if (!moving)
	{
		var rayCastStart : Vector3 = gameObject.transform.position;
		
		var rayCastLeft : Vector3 = rayCastStart + new Vector3 (-1, 0, 0);
		var rayCastRight : Vector3 = rayCastStart + new Vector3 (1, 0, 0);
		var rayCastDown : Vector3 = rayCastStart + new Vector3 (0, 0, -1);
		var rayCastUp : Vector3 = rayCastStart + new Vector3 (0, 0, 1);
		
		//RIGHT
		Debug.DrawLine (rayCastStart, rayCastRight, Color.red);
		//LEFT
		Debug.DrawLine (rayCastStart, rayCastLeft, Color.green);
		//UP
		Debug.DrawLine (rayCastStart, rayCastUp, Color.blue);
		//DOWN
		Debug.DrawLine (rayCastStart, rayCastDown, Color.yellow);
		
		var leftHit : RaycastHit;
		var rightHit : RaycastHit;
		var upHit : RaycastHit;
		var downHit : RaycastHit;
		
		var canGoLeft : boolean = true;
		var canGoRight : boolean = true;
		var canGoUp : boolean = true;
		var canGoDown : boolean = true;
		
		
	    
		if (Physics.Raycast (transform.position, -transform.right, leftHit, 1))
			if (leftHit.collider.tag == "Boundary")
				canGoLeft = false;
		
		if (Physics.Raycast (transform.position, transform.right, rightHit, 1))
			if (rightHit.collider.tag == "Boundary")
				canGoRight = false;
		
		if (Physics.Raycast (transform.position, transform.forward, upHit, 1))
			if (upHit.collider.tag == "Boundary")
				canGoUp = false;
		
		if (Physics.Raycast (transform.position, -transform.forward, downHit, 1))
			if (downHit.collider.tag == "Boundary")
				canGoDown = false;
		
		if (canGoLeft)
			if (Input.GetKey ("left") && !Input.GetKey ("up")) {movingLeft = true; xTarget = gameObject.transform.position.x - distance;}
		
		if (canGoRight)
			if (Input.GetKey ("right") && !Input.GetKey ("down")) {movingRight = true;	xTarget = gameObject.transform.position.x + distance;}
		
		if (canGoDown)
			if (Input.GetKey ("down") && !Input.GetKey ("left")) {movingDown = true; zTarget = gameObject.transform.position.z - distance;}
		
		if (canGoUp)
			if (Input.GetKey ("up") && !Input.GetKey ("right")) {movingUp = true; zTarget = gameObject.transform.position.z + distance;}
	}
	
	
	if (moving)
	{
		//LEFT
		if (movingLeft)
		{
			gameObject.transform.position.x -= (speed*Time.deltaTime);
			if (xPlayer < xTarget)
			{
				gameObject.transform.position.x = xTarget;
				movingLeft = false;
			}
		}
		
		//RIGHT
		if (movingRight)
		{
			gameObject.transform.position.x += (speed*Time.deltaTime);
			if (xPlayer > xTarget)
			{
				gameObject.transform.position.x = xTarget;
				movingRight = false;
			}
		}
		
		//DOWN
		if (movingDown)
		{
			gameObject.transform.position.z -= (speed*Time.deltaTime);
			if (zPlayer < zTarget)
			{
				gameObject.transform.position.z = zTarget;
				movingDown = false;
			}
		}
		
		//UP
		if (movingUp)
		{
			gameObject.transform.position.z += (speed*Time.deltaTime);
			if (zPlayer > zTarget)
			{
				gameObject.transform.position.z = zTarget;
				movingUp = false;
			}
		}
	}
}