﻿#pragma strict

var player : GameObject;
var sprite :GameObject;

var powerCellsRequired : int;
var teleportToX : int;
var teleportToZ : int;

var resetPowerCores : boolean;
var toNextStage : boolean;
var loadLevel : String;

var onTex : Material;
var offTex : Material;

var coreDead : Material;
var coreAlive : Material;

private var teleportFromX : int;
private var teleportFromZ : int;

var powerCell1 : GameObject;
var powerCell2 : GameObject;
var powerCell3 : GameObject;
var powerCell4 : GameObject;

var powerCore1 : GameObject;
var powerCore2 : GameObject;
var powerCore3 : GameObject;
var powerCore4 : GameObject;

var powerBall1 : GameObject;
var powerBall2 : GameObject;
var powerBall3 : GameObject;
var powerBall4 : GameObject;

function Start()
{
	teleportFromX = gameObject.transform.position.x;
	teleportFromZ = gameObject.transform.position.z;
}

function Update()
{
	if (teleportFromX == PlayerControlScript.xPlayer && teleportFromZ == PlayerControlScript.zPlayer)
	{
		if (InventoryScript.powerCells >= powerCellsRequired)
		{
			player.transform.position.x = teleportToX;
			player.transform.position.z = teleportToZ;
			
			SoundEffectScript.teleportMem = true;
			
			if (resetPowerCores)
				InventoryScript.powerCells = 0;
			if (toNextStage)
				++TextControlScript.stage;
			if (loadLevel != "" || loadLevel != null)
				Application.LoadLevel (loadLevel);
		}
	}
	
	if (InventoryScript.powerCells >= powerCellsRequired)
		sprite.renderer.material = onTex;
	else
		sprite.renderer.material = offTex;
	
	if (powerCellsRequired == 0)
	{
		powerCell1.active = false;
		powerCell2.active = false;
		powerCell3.active = false;
		powerCell4.active = false;
	}
	
	if (powerCellsRequired == 1)
	{
		powerCell1.active = true;
		powerCell2.active = false;
		powerCell3.active = false;
		powerCell4.active = false;
	}
	
	if (powerCellsRequired == 2)
	{
		powerCell1.active = true;
		powerCell2.active = true;
		powerCell3.active = false;
		powerCell4.active = false;
	}
	
	if (powerCellsRequired == 3)
	{
		powerCell1.active = true;
		powerCell2.active = true;
		powerCell3.active = true;
		powerCell4.active = false;
	}
	
	if (powerCellsRequired == 4)
	{
		powerCell1.active = true;
		powerCell2.active = true;
		powerCell3.active = true;
		powerCell4.active = true;
	}
	
	if(InventoryScript.powerCells == 0)
	{
		powerCore1.renderer.material = coreDead;
		powerBall1.active = false;
		
		powerCore2.renderer.material = coreDead;
		powerBall2.active = false;
		
		powerCore3.renderer.material = coreDead;
		powerBall3.active = false;
		
		powerCore4.renderer.material = coreDead;
		powerBall4.active = false;
	}
	else if(InventoryScript.powerCells == 1)
	{
		powerCore1.renderer.material = coreAlive;
		powerBall1.active = true;
		
		powerCore2.renderer.material = coreDead;
		powerBall2.active = false;
		
		powerCore3.renderer.material = coreDead;
		powerBall3.active = false;
		
		powerCore4.renderer.material = coreDead;
		powerBall4.active = false;
	}
	else if(InventoryScript.powerCells == 2)
	{
		powerCore1.renderer.material = coreAlive;
		powerBall1.active = true;
		
		powerCore2.renderer.material = coreAlive;
		powerBall2.active = true;
		
		powerCore3.renderer.material = coreDead;
		powerBall3.active = false;
		
		powerCore4.renderer.material = coreDead;
		powerBall4.active = false;
	}
	else if(InventoryScript.powerCells == 3)
	{
		powerCore1.renderer.material = coreAlive;
		powerBall1.active = true;
		
		powerCore2.renderer.material = coreAlive;
		powerBall2.active = true;
		
		powerCore3.renderer.material = coreAlive;
		powerBall3.active = true;
		
		powerCore4.renderer.material = coreDead;
		powerBall4.active = false;
	}
	else if(InventoryScript.powerCells >= 4)
	{
		powerCore1.renderer.material = coreAlive;
		powerBall1.active = true;
		
		powerCore2.renderer.material = coreAlive;
		powerBall2.active = true;
		
		powerCore3.renderer.material = coreAlive;
		powerBall3.active = true;
		
		powerCore4.renderer.material = coreAlive;
		powerBall4.active = true;
	}
}